
#ifndef _CHAT_H_
#define _CHAT_H_

#include "keybinput.h"

#define CHAT_MAX_LINES 255
#define CHAT_BG_SHADE_DARK -64
#define CHAT_BG_SHADE_BRIGHT 64

struct __chat {
	SDL_Rect window;
	signed char visible;
	signed char changed;
	SDL_Surface *oldscreen;
	short int startline;
	short int lastline;
	struct {
		char text[255];
		int status;
	} lines[CHAT_MAX_LINES];
	signed char lineschanged;
	_keybinput input;
} typedef _chat;

extern _chat chat;

extern void chat_show (int x1, int y1, int x2, int y2);
extern void chat_addline (char *text);
extern void chat_addstatusline (char *text);
extern void chat_loop (SDL_Event *event);
extern void chat_drawbox ();
extern void chat_cleanup ();

#endif
